
TYPO3.Fluid - Task # 5636

Task # 26664 (New): Clean up Form ViewHelpers
Task # 26658 (New): Make Form ViewHelpers consistent

Status: Under Review Priority: Must have
Author: Steffen Ritter Category:
Created: 2009-12-05 Assigned To:
Updated: 2013-11-22 Due date:
Has patch: No
Subject: Form_RadioViewHelper and CheckBoxViewHelper miss check for existing object before it is accessed.
Description

If you have an form for creating an Object currently this will fail with an exception.
The other FormViewHelper use the getValue() function to determine an property-value of object assigned to the form.
Since Checkbox/Radiobox has to compare against a value to decide if selected, they have to fetch the property-value on their own.

in getValue a check on $this->viewHelperVariableContainer->exists('Tx_Fluid_ViewHelpers_FormViewHelper', 'formObject') and an
call to $this->addAdditionalIdentityPropertiesIfNeeded(); are performed before acessing the property. If you do so in RadioBox and
Checkbox too, no exception anymore.

regards

Steffen

Related issues:
related to TYPO3.Fluid - Task # 9214: Improve handling of bound properties in... Closed 2010-08-09

History
#1 - 2009-12-09 22:59 - Pascal Jungblut

I can confirm this bug. The patch works fine for me. Thanks Steffen!

regards
Pascal

#2 - 2010-01-25 17:50 - Thomas Deinhamer

I got a similar problem when trying to display a field
of TCA-type 'select' with items defined in the TCA.

The values of the field will get stored as CSV list
in the backend, so the type of the property in Extbase
is 'string'.

The problem is, that the checkbox viewhelper isn't aware
of handling this CSV list. If I enhance my model to return
an array, the whole thing will screw up when the model
gets persisted, as the SQL generated is something like:
"UPDATE table SET csv_field=()"

This happens if the field comes from a form, where
no checkboxes where selected.

Sorry for the sloppy description, but I'm not really aware
of where Extbase/Fluid messes this up or transforms the
variables into other types, etc. It's just I got huge
problems setting/getting 'select' fields (as defined in TCA)
inside my model, for displaying them with Fluid and persisting
them after form submission.

#3 - 2010-06-18 15:11 - Sebastian Kurfuerst
- Project changed from Extbase MVC Framework to TYPO3.Fluid

#4 - 2011-02-03 18:27 - Peter Niederlag
- File radioProperty-5636.diff added

IMO, the Fix by Steffen won't work on recent(>1.3.0) fluid versions. The issue needs to be tackled properly anyway as in #9214.
attached patch at least fixes the exception.

#5 - 2011-02-03 18:30 - Peter Niederlag
- File radioProperty-5636.diff added

updated patch.
Remove  

$this->addAdditionalIdentityPropertiesIfNeeded();

from patch as it sneeked in there by accident

#6 - 2011-05-06 10:10 - Sebastian Kurfuerst
- Parent task set to #26658

#7 - 2011-08-18 19:48 - Mr. Hudson

Patch set 1 of change Ie8a02e019d67e8b7a3a01544e8a643dfaa507db0 has been pushed to the review server.
It is available at http://review.typo3.org/4413

#8 - 2011-08-18 19:54 - Mr. Hudson

Patch set 2 of change Ie8a02e019d67e8b7a3a01544e8a643dfaa507db0 has been pushed to the review server.
It is available at http://review.typo3.org/4413

#9 - 2011-08-18 19:54 - Mr. Hudson

Patch set 3 of change Ie8a02e019d67e8b7a3a01544e8a643dfaa507db0 has been pushed to the review server.
It is available at http://review.typo3.org/4413
#10 - 2011-09-09 15:20 - Robert Lemke
- Target version changed from 1.0 beta 2 to 1.0.0

#11 - 2011-10-20 01:48 - Karsten Dambekalns
- Target version deleted (1.0.0)

#12 - 2012-02-08 10:53 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/4413

#13 - 2012-03-12 14:36 - Christian Müller
- Has patch set to No

maybe this ticket should be moved to the MVC project or closed?

#14 - 2012-08-07 13:23 - Michael Bakonyi

Is there any news about this issue? Unfortunately in 4.7.2 this problem still exists which might extbase/fluid show up like it was still in beta-state to
extension-developers. Is it possible to sponsor parts of the fixing of this bug respectively integrating the offered patches into core?

#15 - 2012-10-15 14:33 - Daniel Siepmann

Using the rewritten property Mapper, adding the following three lines of code to the view helper helped me:

if ($this->configurationManager->isFeatureEnabled('rewrittenPropertyMapper') && $this->hasMappingErrorOccured()) {
    $propertyValue = (boolean)$this->getLastSubmittedFormData();
}

I added them right after assigning the line:

$propertyValue = $this->getPropertyValue();

I don't know whether this will work in all other situations.

Basically it does the same as all other fluid form fields like textfield.
It retrieves the content of the property in the current request.

Perhaps this will help some of you.

#16 - 2013-02-08 20:29 - Gerrit Code Review
Patch set 5 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/4413

Files
exceptionRadioCheckBox.diff 1.7 kB 2009-12-05 Steffen Ritter
radioProperty-5636.diff 1017 Bytes 2011-02-03 Peter Niederlag
radioProperty-5636.diff 962 Bytes 2011-02-03 Peter Niederlag
